package com.tzld.longarticle.recommend.server.service;

import com.tzld.longarticle.recommend.server.common.ThreadPoolFactory;
import com.tzld.longarticle.recommend.server.remote.WxFetchRemoteService;
import com.tzld.longarticle.recommend.server.repository.mapper.crawler.ArticleContentLinkMapper;
import com.tzld.longarticle.recommend.server.repository.model.ArticleContentLink;
import com.tzld.longarticle.recommend.server.repository.model.ArticleContentLinkExample;
import com.tzld.longarticle.recommend.server.util.DateUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.math.NumberUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author dyp
 */
@Service
@Slf4j
public class JobService {

    @Autowired
    private ArticleContentLinkMapper articleContentLinkMapper;
    @Autowired
    private WxFetchRemoteService wxFetchRemoteService;

    private long seconds1d = 60 * 60 * 24 * 1000;
    private long seconds7d = 7 * seconds1d;

    public void syncViewCount() {
        ArticleContentLinkExample example = new ArticleContentLinkExample();

        long now = System.currentTimeMillis();
        long time = now - (now % seconds1d) - seconds7d;

        example.createCriteria().andCreateTimeGreaterThanOrEqualTo(time);
        List<ArticleContentLink> links = articleContentLinkMapper.selectByExample(example);
        for (ArticleContentLink link : links) {
            Map<String, String> content = wxFetchRemoteService.getContent(link.getContentLink());
            link.setTitle(content.getOrDefault("title", ""));
            link.setViewCount(NumberUtils.toLong(content.getOrDefault("view_count", "0"), 0L));
            link.setUpdateTime(System.currentTimeMillis());

            articleContentLinkMapper.updateByPrimaryKey(link);
        }


    }
}
